// 该类 GTaskASyncTask 继承自 AsyncTask，用于执行异步任务，可能是在后台执行 GTask 的同步操作并显示通知
public class GTaskASyncTask extends AsyncTask<Void, String, Integer> {
    // 同步通知的 ID
    private static int GTASK_SYNC_NOTIFICATION_ID = 5234235;


    // 定义一个接口，用于任务完成时的回调
    public interface OnCompleteListener {
        void onComplete();
    }


    // 上下文对象，用于获取系统服务等操作
    private Context mContext;
    // 通知管理器，用于显示通知
    private NotificationManager mNotifiManager;
    // GTask 管理器，可能用于执行实际的同步操作
    private GTaskManager mTaskManager;
    // 完成监听器，用于任务完成时的回调
    private OnCompleteListener mOnCompleteListener;


    // 构造函数，初始化成员变量
    public GTaskASyncTask(Context context, OnCompleteListener listener) {
        mContext = context;
        mOnCompleteListener = listener;
        mNotifiManager = (NotificationManager) mContext
              .getSystemService(Context.NOTIFICATION_SERVICE);
        mTaskManager = GTaskManager.getInstance();
    }


    // 取消同步操作，调用 GTaskManager 的取消同步方法
    public void cancelSync() {
        mTaskManager.cancelSync();
    }


    // 发布进度，调用父类的 publishProgress 方法
    public void publishProgess(String message) {
        publishProgress(new String[] {
            message
        });
    }


    // 显示通知
    private void showNotification(int tickerId, String content) {
        // 创建通知对象，设置图标、时间戳等
        Notification notification = new Notification(R.drawable.notification, mContext
              .getString(tickerId), System.currentTimeMillis());
        notification.defaults = Notification.DEFAULT_LIGHTS;
        notification.flags = Notification.FLAG_AUTO_CANCEL;
        PendingIntent pendingIntent;
        if (tickerId!= R.string.ticker_success) {
            // 根据不同的 tickerId 设置不同的 PendingIntent
            pendingIntent = PendingIntent.getActivity(mContext, 0, new Intent(mContext,
                    NotesPreferenceActivity.class), 0);


        } else {
            pendingIntent = PendingIntent.getActivity(mContext, 0, new Intent(mContext,
                    NotesListActivity.class), 0);
        }
        // 设置通知的详细信息
        notification.setLatestEventInfo(mContext, mContext.getString(R.string.app_name), content,
                pendingIntent);
        mNotifiManager.notify(GTASK_SYNC_NOTIFICATION_ID, notification);
    }


    // 在后台执行的任务，发布登录进度并调用 GTaskManager 的同步方法
    @Override
    protected Integer doInBackground(Void... unused) {
        publishProgess(mContext.getString(R.string.sync_progress_login, NotesPreferenceActivity
              .getSyncAccountName(mContext)));
        return mTaskManager.sync(mContext, this);
    }


    // 在进度更新时显示通知，并根据上下文发送广播
    @Override
    protected void onProgressUpdate(String... progress) {
        showNotification(R.string.ticker_syncing, progress[0]);
        if (mContext instanceof GTaskSyncService) {
            ((GTaskSyncService) mContext).sendBroadcast(progress[0]);
        }
    }


    // 任务执行完成后的操作，根据结果显示不同的通知，并调用完成监听器
    @Override
    protected void onPostExecute(Integer result) {
        if (result == GTaskManager.STATE_SUCCESS) {
            showNotification(R.string.ticker_success, mContext.getString(
                    R.string.success_sync_account, mTaskManager.getSyncAccount()));
            NotesPreferenceActivity.setLastSyncTime(mContext, System.currentTimeMillis());
        } else if (result == GTaskManager.STATE_NETWORK_ERROR) {
            showNotification(R.string.ticker_fail, mContext.getString(R.string.error_sync_network));
        } else if (result == GTaskManager.STATE_INTERNAL_ERROR) {
            showNotification(R.string.ticker_fail, mContext.getString(R.string.error_sync_internal));
        } else if (result == GTaskManager.STATE_SYNC_CANCELLED) {
            showNotification(R.string.ticker_cancel, mContext
                  .getString(R.string.error_sync_cancelled));
        }
        if (mOnCompleteListener!= null) {
            new Thread(new Runnable() {


                public void run() {
                    mOnCompleteListener.onComplete();
                }
            }).start();
        }
    }
}